﻿using System;
using System.Xml.Linq;

namespace MWS.Processing.Interfaces
{
    public interface ISerializer<TSerialize>
    {
        TSerialize Serialize<T>(T item);
        T Deserialize<T>(TSerialize item);
    }

    public interface IXmlSerializer : ISerializer<XElement>
    {
    }

    public interface IByteArraySerializer : ISerializer<byte[]>
    {
    }
}